#ifndef PACKED_IO_HPP
#define PACKED_IO_HPP

#include <Vector/Vector.hpp>

#include <string>
#include <iostream>

#include <stdint.h>

void write_token(std::string val, std::ostream &out);
void write_packed(uint64_t value, std::ostream &out);
void write_packed(unsigned int value, std::ostream &out);
void write_packed(int64_t value, std::ostream &out);
void write_packed(int value, std::ostream &out);
void write_packed(Vector2i value, std::ostream &out);
void write_alpha(std::string const &value, std::ostream &out);
void write_packed(float value, std::ostream &out);
void write_packed(Vector2f value, std::ostream &out);

bool read_token(std::string val, std::istream &in);
bool read_packed(uint64_t &value, std::istream &in);
bool read_packed(unsigned int &value, std::istream &in);
bool read_packed(int64_t &value, std::istream &in);
bool read_packed(int &value, std::istream &in);
bool read_packed(Vector2i &value, std::istream &in);
bool read_alpha(std::string &value, std::istream &in);
bool read_packed(float &value, std::istream &in);
bool read_packed(Vector2f &value, std::istream &in);

#endif //PACKED_IO_HPP
