
#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect instance_tex;
uniform sampler2D field_tex;

uniform vec2 dir;

void main() {
	vec2 instance_coord = gl_TexCoord[1].xy;
	vec2 field_coord = gl_TexCoord[0].xy;
	vec3 instance = texture2DRect(instance_tex, instance_coord).xyz;
	vec2 field = texture2D(field_tex, field_coord).xy;

	instance.xy = vec2(instance.x * dir.x + instance.y * -dir.y, instance.x * dir.y + instance.y * dir.x);

	vec2 difference = (instance.xy - field) * instance.z;

	//How this works:
	// (trans + rot + scale + difference) ^ 2 -->
	//  trans * trans + [trans * rot] + [trans * scale] + trans * difference
	//  rot * rot + rot * scale + rot * difference
	//  scale * scale + scale * difference
	//  difference * difference

	vec2 pos = gl_TexCoord[2].xy;
	vec2 rot_dir = vec2(-pos.y, pos.x);

	gl_FragColor = vec4(dot(rot_dir, difference), dot(difference, difference), difference.x, difference.y);
}
