
#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect posvel_tex;
uniform sampler2DRect color_tex;
uniform sampler2D field_tex;
uniform sampler2D cam_tex;
uniform vec2 world;

void main() {
	vec4 posvel = texture2DRect(posvel_tex, gl_TexCoord[0].xy).xyzw;
	vec2 pos = posvel.xy;
	vec3 color = texture2DRect(color_tex, gl_TexCoord[0].xy).xyz;
	pos /= world;
	vec3 field_color = texture2D(field_tex, pos).xyz;
	vec3 cam_color = texture2D(cam_tex, pos).xyz;
	float speed = abs(posvel.z) + abs(posvel.w);
	color = mix(color, cam_color, max(0.001, 0.05 - speed * 0.3));
	//color = mix(color, field_color, 0.01);
	//color.x = min(color.x + 0.01, 1.0);
	//color = min(1.0, color * (1 + 0.1 * speed));
	gl_FragColor = vec4(color, 1.0);
}
