
#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect posvel_tex;
uniform sampler2D vel_tex;
uniform vec2 world;

void main() {
	vec4 posvel = texture2DRect(posvel_tex, gl_TexCoord[0].xy);
	vec2 pos = posvel.xy;
	vec2 vel = posvel.zw;
	pos += vel * 0.01;
	vel = mix(vel, texture2D(vel_tex, pos / world).xy, 0.05);
	vel *= 0.999;
	pos = mod(pos, world);
	gl_FragColor = vec4(pos, vel);
}
