
uniform sampler2D large_tex;
uniform sampler2D small_tex;

void main() {
	vec2 at = gl_TexCoord[0].xy;
	vec4 current = texture2D(large_tex, at);
	float weight = current.w;
	vec3 val = current.xyz;
	if (weight >= 1.0) {
		val /= weight;
	} else {
		vec3 small = texture2D(small_tex, at).xyz;
		if (weight > 0.0) {
			val = mix(val / weight, small, weight);
		} else {
			val = small;
		}
	}
	gl_FragColor = vec4(val, 1.0); //assume linear blending. whoo.
}
